//
// L1-List, definition
//
#ifndef LST_H
#define LST_H

#include <assert.h>

class L1ListHeader {
public:
    L1ListHeader *next;

    L1ListHeader(): next(0) {}
    L1ListHeader(L1ListHeader *n): next(n) {}

    void link(L1ListHeader *n) { next = n; }
    virtual ~L1ListHeader() {}
};

class L1List {
public:
    L1ListHeader head;

    mutable L1ListHeader* pointerPrev;
    mutable L1ListHeader* pointerNext;

    L1List():
        pointerPrev(&head),
        pointerNext(0)
    {}

    void moveToBeg() const {
        pointerPrev = (L1ListHeader*) &head;
        pointerNext = head.next;
    }

    bool inEnd() const { return (pointerNext == 0); }
    void moveToEnd() const;

    void moveForward() const {
        if (pointerNext != 0) {
            pointerPrev = pointerNext;
            pointerNext = pointerNext->next;
        }
    }

    // Add an element before the pointer.
    // Element must be created in the heap using the "new" operator
    void insertBefore(L1ListHeader* element) {
        element->link(pointerNext);
        pointerPrev->link(element);
        pointerPrev = element;
        assert(pointerPrev->next == pointerNext);
    }

    void removeAll();

    ~L1List() { removeAll(); }
};

#endif
