#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lt.h"

static char cur_label[32];

Label::operator const char*() const {
    return toString(cur_label, 32);
}

char* Label::toString(char *buffer, int maxLen) const {
    char line[32];
    sprintf(line, "%s%d%s", LABEL_PREFIX, number, LABEL_SUFFIX);
    strncpy(buffer, line, maxLen);
    return buffer;
}

Label* LabelTable::findLabel(int n) const {
    moveToBeg();
    while (pointerNext != 0) {
        if (n == ((Label*) pointerNext)->number) {
            return ((Label*) pointerNext);
        }
        moveForward();
    }
    return 0;
}

Label* LabelTable::addLabel(int n) {
    Label *lab = findLabel(n);
    if (lab != 0)
        return lab;
    lab = new Label(n);
    moveToBeg();
    insertBefore(lab);
    return lab;
}
