//
// Name table
//
#ifndef LT_H
#define LT_H
#include <string.h>
#include "lst.h"

class ICommand;

// Labels look like ".L102:"
const char* const LABEL_PREFIX = ".L";
const char* const LABEL_SUFFIX = ":";

class Label: public L1ListHeader {
public:
    int number;
    ICommand *location;

    Label():
        number(0),
        location(0)
    {}

    Label(int n):
        number(n),
        location(0)
    {}

    Label(const char* str);

    bool operator==(const Label& l) const {
        return (number == l.number);
    }

    bool operator!=(const Label& n) const {
        return (!(*this == n));
    }

    operator const char*() const;

    char* toString(char *buffer, int maxLen) const;

    virtual ~Label() {}
};

//
// Label table
//
class LabelTable: public L1List {
public:
    Label* findLabel(int n) const;
    Label* addLabel(int n);
};

#endif
