/*
 * Parser & Scanner Common Definitions
 */
#ifndef PARSER_H
#define PARSER_H

#include "lextypes.h"
#include "strpool.h"
#include "nt.h"
#include "lt.h"
#include "icode.h"
#include "tree.h"

extern StrPool string_pool;
extern NameTable name_table;

/* The type of values associated with terminals and nonterminals */
struct yys {
    const char* name;
    int int_value;
    double double_value;
    TreeNode* tree;
    NameDef* nameDef;
    Label* label1;
    Label* label2;
    Label* saved_label1;
    Label* saved_label2;
};

#define YYSTYPE yys

#include "comp.hpp"     /* File generated automatically by bison: */
                        /* contains the definitions of terminals  */

int yylex();              /* Prototype of the scanner function "next lexeme" */
int yyerror(const char*); /* Prototype of the error diagnostics function     */

extern int yylineno;

#endif
