#ifndef STRPOOL_H
#define STRPOOL_H

#include <string.h>
#include "lst.h"

//
// Definition of constant string
//
class StrDef: public L1ListHeader {
public:
    char *str;
    StrDef():
        str(0)
    {}

    StrDef(const StrDef& s):
        str(0)
    {
        if (s.str != 0) {
            int len = strlen(s.str);
            str = new char[len + 1];
            memmove(str, s.str, len+1);
        }
    }

    StrDef(const char *s):
        str(0)
    {
        if (s != 0) {
            int len = strlen(s);
            str = new char[len + 1];
            memmove(str, s, len+1);
        }
    }

    StrDef& operator=(const StrDef& s) {
        delete[] str; str = 0;
        if (s.str != 0) {
            int len = strlen(s.str);
            str = new char[len + 1];
            memmove(str, s.str, len+1);
        }
        return *this;
    }

    operator const char*() const {
        return str;
    }

    virtual ~StrDef() {
        delete [] str;
    }
};

//
// Pool of string definitions
//
class StrPool: public L1List {
public:
    StrDef* findString(const char *str) const;
    const char *addString(const char *str);
};

#endif
